# 1.APP启动

```
{
   event_name:  "app_stage",
   device_id:"",                    
   event_data: [{
       inter: "4G",                 // 网络情况
       app_channel: "",             // APP下载渠道
       app_version: "1.0.0",        // APP版本号

       type: 2,                     // 1:启动APP, 2:APP从后台回到前台
       appear_time: "1611540208",   // 启动时间
       disappear_time: "1611540208",// 关闭时间
       extras: {                    // 此数据为自定义数据
           user_id:  "66713",       // 用户id
           source: 2,               // 来源
           ...
       }
   }]
}
```
# 2.页面游览
```
{
   event_name:  "page_scan",
   event_data: [{     
       inter: "4G",                     // 网络情况
       app_channel: "",                 // APP下载渠道
       app_version: "1.0.0",            // APP版本号

       page_id: "com.qm.app.goods",     // 页面ID
       last_page_id: "com.qm.app.home", // 上一个页面ID      
       appear_time: "1611540208",       // 启动时间
       disappear_time: "1611540208",    // 关闭时间
       extras: {                        // 此数据为自定义数据
           user_id:  "66713",           // 用户id
           source: 2,                   // 来源
           goods_id: "15112231541",     // 商品ID
           ...
       }
   }]
}
```

# 3.点击
```
{
   event_name:  "elem_click",
   event_data: [{
       inter: "4G",                     // 网络情况
       app_channel: "",                 // APP下载渠道
       app_version: "1.0.0",            // APP版本号

       page_id: "com.qm.app.goods",     // 页面ID
       click_id: "button",              // 点击ID    
       click_time: "1611540208",        // 点击时间
       extras: {                        // 此数据为自定义数据
           user_id:  "66713",           // 用户id
           source: 2,                   // 来源
           goods_id: "15112231541",     // 商品ID
           ...
       }
   }]
}
```

# 4.曝光
```
{
   event_name:  "elem_exposure",
   event_data: [{
       inter: "4G",                     // 网络情况
       app_channel: "",                 // APP下载渠道
       app_version: "1.0.0",            // APP版本号

       page_id: "com.qm.app.goods",     // 页面ID
       exposure_id: "order_good_list",  // 曝光ID
       exposure_time: "1611540208",     // 曝光时间
       extras: {                        // 此数据为自定义数据
           user_id:  "66713",           // 用户id
           source: 2,                   // 来源
           goods_id: "15112231541",     // 商品ID
           ...
       }
   }]
}
```


# API数据格式
```
{
    device_id:"",
    projects:[{
        event_name:  "app_stage",
        ...
    },{
        event_name:  "page_scan",
        ...
    },{
        event_name:  "elem_click",
        ...
    },{
        event_name:  "elem_exposure",
        ...
    },{
        event_name:  "app_stage",
        ...
    },{
        event_name:  "page_scan",
        ...
    },{
        event_name:  "elem_click",
        ...
    },{
        event_name:  "elem_exposure",
        ...
    }]
   
}
```


## 数据上报
1. APP启动上报(回到前台)
2. 定时上报


## APP启动和页面游览上报
1. APP启动(进入前台)->APP关闭(进入后台),算一次上报
2. 页面启动(进入前台)->页面关闭(进入后台),算一次上报

## APP被杀死上报
1. APP被杀死时,APP和游览页面没有关闭关闭时间，正常情况无法算一次上报，在APP启动时直接上报所有